<?php

namespace Pepitelabs\PWS;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'TrackPackagesByPinRequestContainer' => '\\Pepitelabs\\PWS\\TrackingService\\TrackPackagesByPinRequestContainer',
            'RequestContainer' => '\\Pepitelabs\\PWS\\TrackingService\\RequestContainer',
            'ArrayOfPIN' => '\\Pepitelabs\\PWS\\TrackingService\\ArrayOfPIN',
            'PIN' => '\\Pepitelabs\\PWS\\TrackingService\\PIN',
            'RequestContext' => '\\Pepitelabs\\PWS\\TrackingService\\RequestContext',
            'TrackPackagesByPinResponseContainer' => '\\Pepitelabs\\PWS\\TrackingService\\TrackPackagesByPinResponseContainer',
            'ResponseContainer' => '\\Pepitelabs\\PWS\\TrackingService\\ResponseContainer',
            'ResponseInformation' => '\\Pepitelabs\\PWS\\TrackingService\\ResponseInformation',
            'ArrayOfError' => '\\Pepitelabs\\PWS\\TrackingService\\ArrayOfError',
            'Error' => '\\Pepitelabs\\PWS\\TrackingService\\Error',
            'ArrayOfInformationalMessage' => '\\Pepitelabs\\PWS\\TrackingService\\ArrayOfInformationalMessage',
            'InformationalMessage' => '\\Pepitelabs\\PWS\\TrackingService\\InformationalMessage',
            'ArrayOfTrackingInformation' => '\\Pepitelabs\\PWS\\TrackingService\\ArrayOfTrackingInformation',
            'TrackingInformation' => '\\Pepitelabs\\PWS\\TrackingService\\TrackingInformation',
            'ArrayOfScan' => '\\Pepitelabs\\PWS\\TrackingService\\ArrayOfScan',
            'Scan' => '\\Pepitelabs\\PWS\\TrackingService\\Scan',
            'Depot' => '\\Pepitelabs\\PWS\\TrackingService\\Depot',
            'InternationalOutboundScan' => '\\Pepitelabs\\PWS\\TrackingService\\InternationalOutboundScan',
            'InternationalOutboundScanDetails' => '\\Pepitelabs\\PWS\\TrackingService\\InternationalOutboundScanDetails',
            'UndeliverableScan' => '\\Pepitelabs\\PWS\\TrackingService\\UndeliverableScan',
            'UndeliverableScanDetails' => '\\Pepitelabs\\PWS\\TrackingService\\UndeliverableScanDetails',
            'OnDeliveryScan' => '\\Pepitelabs\\PWS\\TrackingService\\OnDeliveryScan',
            'OnDeliveryScanDetails' => '\\Pepitelabs\\PWS\\TrackingService\\OnDeliveryScanDetails',
            'ProofOfPickUpScan' => '\\Pepitelabs\\PWS\\TrackingService\\ProofOfPickUpScan',
            'ProofOfPickUpScanDetails' => '\\Pepitelabs\\PWS\\TrackingService\\ProofOfPickUpScanDetails',
            'Address' => '\\Pepitelabs\\PWS\\TrackingService\\Address',
            'PhoneNumber' => '\\Pepitelabs\\PWS\\TrackingService\\PhoneNumber',
            'DeliveryScan' => '\\Pepitelabs\\PWS\\TrackingService\\DeliveryScan',
            'DeliveryScanDetails' => '\\Pepitelabs\\PWS\\TrackingService\\DeliveryScanDetails',
            'ResponseContext' => '\\Pepitelabs\\PWS\\TrackingService\\ResponseContext',
            'TrackPackagesByReferenceRequestContainer' => '\\Pepitelabs\\PWS\\TrackingService\\TrackPackagesByReferenceRequestContainer',
            'TrackPackageByReferenceSearchCriteria' => '\\Pepitelabs\\PWS\\TrackingService\\TrackPackageByReferenceSearchCriteria',
            'TrackPackagesByReferenceResponseContainer' => '\\Pepitelabs\\PWS\\TrackingService\\TrackPackagesByReferenceResponseContainer',
            'GetDeliveryDetailsRequestContainer' => '\\Pepitelabs\\PWS\\TrackingService\\GetDeliveryDetailsRequestContainer',
            'GetDeliveryDetailsResponseContainer' => '\\Pepitelabs\\PWS\\TrackingService\\GetDeliveryDetailsResponseContainer',
            'ValidationFault' => '\\Pepitelabs\\PWS\\TrackingService\\ValidationFault',
            'ArrayOfValidationDetail' => '\\Pepitelabs\\PWS\\TrackingService\\ArrayOfValidationDetail',
            'ValidationDetail' => '\\Pepitelabs\\PWS\\TrackingService\\ValidationDetail',
        );
    }
}
