<?php

namespace Pepitelabs\PWS\TrackingService;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfScan TrackingService
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfScan
 * @subpackage Arrays
 */
class ArrayOfScan extends AbstractStructArrayBase
{
    /**
     * The Scan
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\TrackingService\Scan[]
     */
    public $Scan;
    /**
     * Constructor method for ArrayOfScan
     * @uses ArrayOfScan::setScan()
     * @param \Pepitelabs\PWS\TrackingService\Scan[] $scan
     */
    public function __construct(array $scan = array())
    {
        $this
            ->setScan($scan);
    }
    /**
     * Get Scan value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\TrackingService\Scan[]|null
     */
    public function getScan()
    {
        return isset($this->Scan) ? $this->Scan : null;
    }
    /**
     * This method is responsible for validating the values passed to the setScan method
     * This method is willingly generated in order to preserve the one-line inline validation within the setScan method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateScanForArrayConstraintsFromSetScan(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfScanScanItem) {
            // validation for constraint: itemType
            if (!$arrayOfScanScanItem instanceof \Pepitelabs\PWS\TrackingService\Scan) {
                $invalidValues[] = is_object($arrayOfScanScanItem) ? get_class($arrayOfScanScanItem) : sprintf('%s(%s)', gettype($arrayOfScanScanItem), var_export($arrayOfScanScanItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Scan property can only contain items of type \Pepitelabs\PWS\TrackingService\Scan, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Scan value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\TrackingService\Scan[] $scan
     * @return \Pepitelabs\PWS\TrackingService\ArrayOfScan
     */
    public function setScan(array $scan = array())
    {
        // validation for constraint: array
        if ('' !== ($scanArrayErrorMessage = self::validateScanForArrayConstraintsFromSetScan($scan))) {
            throw new \InvalidArgumentException($scanArrayErrorMessage, __LINE__);
        }
        if (is_null($scan) || (is_array($scan) && empty($scan))) {
            unset($this->Scan);
        } else {
            $this->Scan = $scan;
        }
        return $this;
    }
    /**
     * Add item to Scan value
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\TrackingService\Scan $item
     * @return \Pepitelabs\PWS\TrackingService\ArrayOfScan
     */
    public function addToScan(\Pepitelabs\PWS\TrackingService\Scan $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pepitelabs\PWS\TrackingService\Scan) {
            throw new \InvalidArgumentException(sprintf('The Scan property can only contain items of type \Pepitelabs\PWS\TrackingService\Scan, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Scan[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pepitelabs\PWS\TrackingService\Scan|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pepitelabs\PWS\TrackingService\Scan|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pepitelabs\PWS\TrackingService\Scan|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pepitelabs\PWS\TrackingService\Scan|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pepitelabs\PWS\TrackingService\Scan|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Scan
     */
    public function getAttributeName()
    {
        return 'Scan';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\TrackingService\ArrayOfScan
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
