<?php

namespace Pepitelabs\PWS\TrackingService;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTrackingInformation TrackingService
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTrackingInformation
 * @subpackage Arrays
 */
class ArrayOfTrackingInformation extends AbstractStructArrayBase
{
    /**
     * The TrackingInformation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\TrackingService\TrackingInformation[]
     */
    public $TrackingInformation;
    /**
     * Constructor method for ArrayOfTrackingInformation
     * @uses ArrayOfTrackingInformation::setTrackingInformation()
     * @param \Pepitelabs\PWS\TrackingService\TrackingInformation[] $trackingInformation
     */
    public function __construct(array $trackingInformation = array())
    {
        $this
            ->setTrackingInformation($trackingInformation);
    }
    /**
     * Get TrackingInformation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\TrackingService\TrackingInformation[]|null
     */
    public function getTrackingInformation()
    {
        return isset($this->TrackingInformation) ? $this->TrackingInformation : null;
    }
    /**
     * This method is responsible for validating the values passed to the setTrackingInformation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTrackingInformation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTrackingInformationForArrayConstraintsFromSetTrackingInformation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfTrackingInformationTrackingInformationItem) {
            // validation for constraint: itemType
            if (!$arrayOfTrackingInformationTrackingInformationItem instanceof \Pepitelabs\PWS\TrackingService\TrackingInformation) {
                $invalidValues[] = is_object($arrayOfTrackingInformationTrackingInformationItem) ? get_class($arrayOfTrackingInformationTrackingInformationItem) : sprintf('%s(%s)', gettype($arrayOfTrackingInformationTrackingInformationItem), var_export($arrayOfTrackingInformationTrackingInformationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TrackingInformation property can only contain items of type \Pepitelabs\PWS\TrackingService\TrackingInformation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TrackingInformation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\TrackingService\TrackingInformation[] $trackingInformation
     * @return \Pepitelabs\PWS\TrackingService\ArrayOfTrackingInformation
     */
    public function setTrackingInformation(array $trackingInformation = array())
    {
        // validation for constraint: array
        if ('' !== ($trackingInformationArrayErrorMessage = self::validateTrackingInformationForArrayConstraintsFromSetTrackingInformation($trackingInformation))) {
            throw new \InvalidArgumentException($trackingInformationArrayErrorMessage, __LINE__);
        }
        if (is_null($trackingInformation) || (is_array($trackingInformation) && empty($trackingInformation))) {
            unset($this->TrackingInformation);
        } else {
            $this->TrackingInformation = $trackingInformation;
        }
        return $this;
    }
    /**
     * Add item to TrackingInformation value
     * @throws \InvalidArgumentException
     * @param \Pepitelabs\PWS\TrackingService\TrackingInformation $item
     * @return \Pepitelabs\PWS\TrackingService\ArrayOfTrackingInformation
     */
    public function addToTrackingInformation(\Pepitelabs\PWS\TrackingService\TrackingInformation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pepitelabs\PWS\TrackingService\TrackingInformation) {
            throw new \InvalidArgumentException(sprintf('The TrackingInformation property can only contain items of type \Pepitelabs\PWS\TrackingService\TrackingInformation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TrackingInformation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Pepitelabs\PWS\TrackingService\TrackingInformation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Pepitelabs\PWS\TrackingService\TrackingInformation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Pepitelabs\PWS\TrackingService\TrackingInformation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Pepitelabs\PWS\TrackingService\TrackingInformation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Pepitelabs\PWS\TrackingService\TrackingInformation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TrackingInformation
     */
    public function getAttributeName()
    {
        return 'TrackingInformation';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\TrackingService\ArrayOfTrackingInformation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
