<?php

namespace Pepitelabs\PWS\TrackingService;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetDeliveryDetailsResponseContainer TrackingService
 * Meta information extracted from the WSDL
 * - documentation: GetDeliveryDetailsResponse
 * - nillable: true
 * - type: tns:GetDeliveryDetailsResponseContainer
 * @subpackage Structs
 */
class GetDeliveryDetailsResponseContainer extends ResponseContainer
{
    /**
     * The DeliveryDetails
     * Meta information extracted from the WSDL
     * - documentation: DeliveryDetails - DeliveryScan
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\TrackingService\DeliveryScan
     */
    public $DeliveryDetails;
    /**
     * Constructor method for GetDeliveryDetailsResponseContainer
     * @uses GetDeliveryDetailsResponseContainer::setDeliveryDetails()
     * @param \Pepitelabs\PWS\TrackingService\DeliveryScan $deliveryDetails
     */
    public function __construct(\Pepitelabs\PWS\TrackingService\DeliveryScan $deliveryDetails = null)
    {
        $this
            ->setDeliveryDetails($deliveryDetails);
    }
    /**
     * Get DeliveryDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\TrackingService\DeliveryScan|null
     */
    public function getDeliveryDetails()
    {
        return isset($this->DeliveryDetails) ? $this->DeliveryDetails : null;
    }
    /**
     * Set DeliveryDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pepitelabs\PWS\TrackingService\DeliveryScan $deliveryDetails
     * @return \Pepitelabs\PWS\TrackingService\GetDeliveryDetailsResponseContainer
     */
    public function setDeliveryDetails(\Pepitelabs\PWS\TrackingService\DeliveryScan $deliveryDetails = null)
    {
        if (is_null($deliveryDetails) || (is_array($deliveryDetails) && empty($deliveryDetails))) {
            unset($this->DeliveryDetails);
        } else {
            $this->DeliveryDetails = $deliveryDetails;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\TrackingService\GetDeliveryDetailsResponseContainer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
