<?php

namespace Pepitelabs\PWS\TrackingService;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OnDeliveryScanDetails TrackingService
 * Meta information extracted from the WSDL
 * - documentation: OnDeliveryScanDetails
 * - nillable: true
 * - type: tns:OnDeliveryScanDetails
 * @subpackage Structs
 */
class OnDeliveryScanDetails extends AbstractStructBase
{
    /**
     * The DeliveryAddress
     * Meta information extracted from the WSDL
     * - documentation: DeliveryAddress - string
     * - nillable: true
     * @var string
     */
    public $DeliveryAddress;
    /**
     * Constructor method for OnDeliveryScanDetails
     * @uses OnDeliveryScanDetails::setDeliveryAddress()
     * @param string $deliveryAddress
     */
    public function __construct($deliveryAddress = null)
    {
        $this
            ->setDeliveryAddress($deliveryAddress);
    }
    /**
     * Get DeliveryAddress value
     * @return string|null
     */
    public function getDeliveryAddress()
    {
        return $this->DeliveryAddress;
    }
    /**
     * Set DeliveryAddress value
     * @param string $deliveryAddress
     * @return \Pepitelabs\PWS\TrackingService\OnDeliveryScanDetails
     */
    public function setDeliveryAddress($deliveryAddress = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryAddress) && !is_string($deliveryAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deliveryAddress, true), gettype($deliveryAddress)), __LINE__);
        }
        $this->DeliveryAddress = $deliveryAddress;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\TrackingService\OnDeliveryScanDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
